
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MYSQL存储过程和函数学习笔记 / 憋错料</title>

    <meta name="description" content="MYSQL存储过程和函数学习笔记 学至Tarena金牌讲师何山,金色晨曦科技公司技术总监沙利穆课程笔记的综合. 1. 什么是存储过程和函数 将SQL语句放入一个集合里,然后直接调用存储过程和函数来执行已经定义好的SQL语句,通过存储过程和函数,可以避免开发人员重复编写相同的SQL语句. MYSQL存储过程和函数是保存在服务器中,在服务器中存储和执行,可以减少客户端和服务器端之间数据传输的消耗. 存储过程就是一组已经保存在数据库中的语句,并且可以随时地调用. 存储过程允许标准组件式编程,存储过程在被创建以后可以在程序中被多次调用而">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">MYSQL存储过程和函数学习笔记</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>学至Tarena金牌讲师何山，金色晨曦科技公司技术总监沙利穆课程笔记的综合。</p>
<p><strong>1. </strong><strong>什么是存储过程和函数</strong></p>
<p>将SQL语句放入一个集合里，然后直接调用存储过程和函数来执行已经定义好的SQL语句，通过存储过程和函数，可以避免开发人员重复编写相同的SQL语句。</p>
<p>MYSQL存储过程和函数是保存在服务器中，在服务器中存储和执行，可以减少客户端和服务器端之间数据传输的消耗。</p>
<p>存储过程就是一组已经保存在数据库中的语句，并且可以随时地调用。</p>
<p>存储过程允许标准组件式编程，存储过程在被创建以后可以在程序中被多次调用而不必重新编写该存储过程的SQL语句，而且数据库专业人员可随时对存储过程进行修改，但对应用程序源代码毫无影响。因为应用程序源代码只包含存储过程的调用语句从而极大地提高了程序的可移植性。</p>
<p><strong>1.1 </strong><strong>什么时候要用到存储过程（存储过程的特点）：</strong></p>
<p>（1）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 存储过程是在服务器端运行的，它的执行速度比较快。</p>
<p>（2）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 存储过程执行一次后，就会驻留在高处缓冲存储器中，在以后的操作中，只需要从高处缓冲存储器中调用已经编译好的二进制代码来执行，这样就能提高系统的性能和响应时间。</p>
<p>（3）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 使用存储过程，可以确保数据库的安全，因为使用存储过程可以完成数据库的所有操作，因为可以把想要进行的操作都放入SQL语句中，然后通过编程的方式来控制对数据库的访问权限。</p>
<p><strong>1.2 </strong><strong>利用mysql</strong><strong>的存储过程比单独执行mysql</strong><strong>的优势在哪里？好处有什么？</strong></p>
<p>计算机上调用Transaction-SQL 编写的一段程序原因在于存储过程具有以下优点</p>
<p><strong>1 </strong><strong>存储过程允许标准组件式编程</strong></p>
<p>存储过程在被创建以后可以在程序中被多次调用，而不必重新编写该存储过程的SQL语句，而且数据库专业人员可随时对存储过程进行修改，但对应用程序源代码毫无影响，因</p>
<p>为应用程序源代码只包含存储过程的调用语句，从而极大地提高了程序的可移植性</p>
<p><strong>2 </strong><strong>存储过程能够实现较快的执行速度</strong></p>
<p>如果某一操作包含大量的Transaction-SQL 代码，或分别被多次执行那么存储过程要比批处理的执行速度快很多。因为存储过程是预编译的，在首次运行一个存储过程时，查询优化器对其进行分析优化，并给出最终被存在系统表中的执行计划，而批处理的Transaction-SQL 语句在每次运行时都要进行编译和优化，因此速度相对要慢一些</p>
<p><strong>3 </strong><strong>存储过程能够减少网络流量</strong></p>
<p>对于同一个针对数据数据库对象的操作，如查询、修改，如果这一操作所涉及到的Transaction-SQL 语句被组织成一存储过程，那么当在客户计算机上调用该存储过程时，网络中传送的只是该调用语句，否则将是多条SQL 语句从而大大增加了网络流量降低网络负载</p>
<p><strong>4 </strong><strong>存储过程可被作为一种安全机制来充分利用</strong></p>
<p>系统管理员通过对执行某一存储过程的权限，进行限制从而能够实现对相应的数据访问权限的限制，避免非授权用户对数据的访问，保证数据的安全。</p>
<p><strong>2. </strong><strong>创建存储过程：</strong></p>
<p>CREATE PROCEDURE sp_name</p>
<p>([proc_parameter[,&hellip;]])</p>
<p>[characteristic]</p>
<p>Routine_body</p>
<p><strong>说明：</strong></p>
<p>Sp_name：存储过程名称，自定义，尽量起一个有意义的名称</p>
<p>([proc_parameter[,&hellip;]]):需要接收或者输出的参数</p>
<p>[characteristic]：特性</p>
<p>Routine_body：要执行的代码，写在BEGIN和END中，BEGIN和END类似于函数体的{}</p>
<p><strong>3.</strong><strong>存储过程的参数：</strong></p>
<p><strong>3.1 </strong><strong>输入输出的参数</strong></p>
<p><strong>输入输出的参数 </strong><strong>参数的名称 </strong><strong>参数的类型</strong></p>
<p>3.1.1<strong>输入输出的参数包括：</strong></p>
<p>IN:输入，把外界的数据传递到存储过程当中</p>
<p>OUT:输出，把存储过程的运算结果传递到外界</p>
<p>INOUT:输入输出，既可以把外界的数据传递到存储过程当中，又可以把存储过程的运算结果传递到外界</p>
<p><strong>3.1.2</strong><strong>参数的类型</strong></p>
<p>可以是MYSQL数据库中的任意类型</p>
<p><strong>3.1.3 </strong><strong>特性</strong></p>
<p>LANGUAGE SQL：默认的，说明Routine_body部分是由SQL语句注册，即数据库默认的语言</p>
<p>DETERMINISTIC：指明存储过程执行的结果是确定的，每次执行存储过程的时候，相同的输入会得到相同的输出。</p>
<p>NOT DETERMINISTIC：指明存储过程执行的结果不是确定的，每次执行存储过程的时候，相同的输入会得到不同的输出，默认情况下，结果是非确定的。</p>
<p><strong>子查询使用SQL</strong><strong>语句的限制：</strong></p>
<p>CONTAINS SQL：表示子程序中可以包含SQL语句，但不包含读或写数据。默认情况下使用该限制。</p>
<p>NO SQL:不包含SQL语句</p>
<p>READS SQL DATA:包含查询数据的语句</p>
<p>MODIFIES SQL DATA:包含写数据的语句</p>
<p>--</p>
<p>SQL SECURITY DEFINER / INVOKER：谁有权限来执行这个存储过程，DEFINER（默认）表示只有定义者自己可以执行，INVOKER表示调用者可以执行。</p>
<p><strong>3.1.4 </strong><strong>注释</strong></p>
<p>COMMENT &nbsp;&lsquo;string&rsquo;</p>
<p>&lsquo;string&rsquo;：注释信息，可以在创建存储过程的时候指定注释。</p>
<p><strong>4. </strong><strong>改变存储过程默认的定界符</strong></p>
<p><strong>通过DELIMITER</strong><strong>来改变</strong></p>
<p>例子：</p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE sp_demo1()</p>
<p>BEGIN</p>
<p>SELECT * FROM users2;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;.</p>
<p>Query OK, 0 rows affected (0.28 sec)</p>
<p>说明：因为存储过程也包含了很多SQL语句，而这些SQL语句也都是以分号结尾的，为了避免定界符的冲突，所以使用DELINITER来改变定界符</p>
<p><strong>注意：</strong></p>
<p><strong>（1</strong><strong>）DELIMITER</strong><strong>与定界符之间，一定要有一个空格，否则设置将无效。</strong></p>
<p>（2）要注意每次创建存储过程结束后，要将定界符恢复为分号，这是一个好的习惯。</p>
<p><strong>5.</strong><strong>创建带参数的存储过程：</strong></p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE age_from_user2(IN user_id INT,OUT user_age INT)</p>
<p>READS SQL DATA</p>
<p>BEGIN</p>
<p>SELECT age INTO user_age FROM user</p>
<p>WHERE id=user_id;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;.</p>
<p>说明：</p>
<p>（1） INT表示参数的返回值，或者说是参数的数据类型</p>
<p>（2）INTO 参数名：表示将SQL语句执行的结果赋给INTO后面的参数中</p>
<p><strong>创建IN</strong><strong>参数的存储过程的例子：</strong></p>
<p>查询订货量大于外界所传递进来的参数p_in的订单数据</p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc2(IN p_in INT)</p>
<p>BEGIN</p>
<p>SELECT * FROM `order` WHERE onum&gt;p_in;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p><strong>创建带有OUT</strong><strong>输出参数的例子：</strong></p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc3(OUT p_out INT )</p>
<p>BEGIN</p>
<p>SELECT count(*) INTO p_out FROM custom;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>说明：INTO 参数名：表示将count(*)的结果赋给INTO后面的参数中</p>
<p><strong>创建带有INOUT</strong><strong>输入输出参数的存储过程：</strong></p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc4(INOUT p_io INT)</p>
<p>BEGIN</p>
<p>SET p_io=5;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p><strong>6.</strong><strong>创建存储函数</strong></p>
<p>存储过程与存储函数本质上是相同的，都属于存储程序，也就是保存在数据库当中的程序，用的时候，都可以随时调用。</p>
<p><strong>6.1 </strong><strong>存储过程与存储函数的区别</strong></p>
<p>（1）存储过程可以指定IN、OUT参数，存储函数不需要指定输入输出参数，存储函数所有的参数都属于IN参数。</p>
<p>（2）存储函数可以通过RETURN语句将运算的结果返回，但是存储过程不允许调用RETURN语句，存储过程可以通过调用OUT参数，将运算的结果返回给外界。</p>
<p><strong>6.2 </strong><strong>创建存储函数</strong></p>
<p>CREATE FUNCTION&nbsp; func_name ([func_parameter[&hellip;]])</p>
<p>RETURNS type</p>
<p>[characteristic&hellip;]</p>
<p>Routine_body</p>
<p>说明：</p>
<p>RETURN type：表示返回值的类型</p>
<p>[characteristic&hellip;]：表示函数的特性，与存储过程的特性一致</p>
<p>例子：</p>
<p>DELIMITER //</p>
<p>CREATE FUNCTION username_from_user(user_id INT)</p>
<p>RETURNS VARCHAR(20)</p>
<p>BEGIN</p>
<p>RETURN (SELECT username FROM users2 WHERE id=user_id);</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>说明：</p>
<p>RETURNS 是指定返回值的数据类型</p>
<p>RETURN() 是将返回结果反馈给外界。</p>
<p><strong>7.</strong><strong>调用存储过程</strong></p>
<p><strong>CALL sp_name ([parameter[,&hellip;]])</strong></p>
<p>注意：</p>
<p>（1）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 调用的时候，一定要有执行的权限</p>
<p>（2）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 调用之后，系统执行存储过程的语句，然后将输出结果返回</p>
<p>例子：</p>
<p>CALL sp_demo1();</p>
<p><strong>7.1</strong><strong>调用有参数的存储过程：</strong></p>
<p>先创建一个存储过程：</p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE age_from_user2(IN user_id INT,OUT user_age INT)</p>
<p>READS SQL DATA</p>
<p>BEGIN</p>
<p>SELECT age INTO user_age FROM user</p>
<p>WHERE id=user_id;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>然后调用这个存储过程，注意，变量用@变量名称</p>
<p>CALL age_from_user2(120,@use_age);</p>
<p>查看变量的值：</p>
<p>mysql&gt; SELECT @use_age;</p>
<p>+----------+</p>
<p>| @use_age |</p>
<p>+----------+</p>
<p>|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 22 |</p>
<p>+----------+</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>7.2</strong><strong>调用有IN</strong><strong>参数的存储过程：</strong></p>
<p><strong>创建IN</strong><strong>参数的存储过程的例子：</strong></p>
<p>查询订货量大于外界所传递进来的参数p_in的订单数据</p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc2(IN p_in INT)</p>
<p>BEGIN</p>
<p>SELECT * FROM `order` WHERE onum&gt;p_in;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p><strong>调用有IN</strong><strong>参数的存储过程：</strong></p>
<p>SET @num=10;</p>
<p>CALL proc2(@num);</p>
<p><strong>7.3</strong><strong>带有OUT</strong><strong>参数的存储过程的调用</strong></p>
<p><strong>创建带有OUT</strong><strong>输出参数的例子：</strong></p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc3(OUT p_out INT )</p>
<p>BEGIN</p>
<p>SELECT count(*) INTO p_out FROM custom;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>说明：INTO 参数名：表示将count(*)的结果赋给INTO后面的参数中</p>
<p>调用存储过程：</p>
<p>mysql&gt; SET @amount=0;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; CALL proc3(@amount);</p>
<p>Query OK, 1 row affected (0.00 sec)</p>
<p>mysql&gt; SELECT @amount;</p>
<p>+---------+</p>
<p>| @amount |</p>
<p>+---------+</p>
<p>|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 4 |</p>
<p>+---------+</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>7.4 </strong><strong>调用有INOUT</strong><strong>参数的存储过程</strong></p>
<p><strong>创建带有INOUT</strong><strong>输入输出参数的存储过程：</strong></p>
<p>DELIMITER //</p>
<p>CREATE PROCEDURE proc4(INOUT p_io INT)</p>
<p>BEGIN</p>
<p>SET p_io=5;</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p><strong>调用有INOUT</strong><strong>参数的存储过程：</strong></p>
<p>mysql&gt; SET @num=-1;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; CALL proc4(@num);</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; SELECT @num;</p>
<p>+------+</p>
<p>| @num |</p>
<p>+------+</p>
<p>|&nbsp;&nbsp;&nbsp; 5 |</p>
<p>+------+</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>8.</strong><strong>调用存储函数</strong></p>
<p>调用存储函数与调用系统函数的格式是一样的。</p>
<p><strong>SELECT func_name([parameter[,&hellip;]]);</strong></p>
<p><strong>&nbsp;</strong></p>
<p>例子：</p>
<p>创建存储函数：</p>
<p>DELIMITER //</p>
<p>CREATE FUNCTION username_from_user(user_id INT)</p>
<p>RETURNS VARCHAR(20)</p>
<p>BEGIN</p>
<p>RETURN (SELECT username FROM users2 WHERE id=user_id);</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>调用存储函数：</p>
<p>mysql&gt; SELECT username_from_user(120);</p>
<p>+-------------------------------------+</p>
<p>| username_from_user(120) |</p>
<p>+-------------------------------------+</p>
<p>| nihao&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>+-------------------------------------+</p>
<p>1 row in set (0.05 sec)</p>
<p><strong>调用存储函数例子：</strong></p>
<p><strong>先创建存储函数</strong></p>
<p>DELIMITER //</p>
<p>CREATE FUNCTION func1(id CHAR)</p>
<p>RETURNS VARCHAR(10)</p>
<p>BEGIN</p>
<p>RETURN(SELECT cname FROM custom WHERE cid=id);</p>
<p>END</p>
<p>//</p>
<p>DELIMITER ;</p>
<p>调用存储函数：</p>
<p>mysql&gt; SET @id=‘110002‘;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; SET @name=‘‘;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; SELECT func1(@id) INTO @name;</p>
<p>Query OK, 1 row affected (0.00 sec)</p>
<p>mysql&gt; SELECT @name;</p>
<p>+--------------------------------------------+</p>
<p>| @name&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>+--------------------------------------------+</p>
<p>| 湖北众合粮油工业有限公司 |</p>
<p>+--------------------------------------------+</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>9. </strong><strong>查看已创建好的存储过程和函数：</strong></p>
<p>查看存储过程：SHOW PROCEDURE STATUS LIKE &lsquo;sp_name&rsquo;;</p>
<p>查看存储函数：SHOW FUNCTION STATUS LIKE &lsquo;func_name&rsquo;;</p>
<p>查看全部存储过程：SHOW PROCEDURE STATUS \G</p>
<p>查看全部存储函数：SHOW FUNCTION STATUS \G</p>
<p>注意：&lsquo;sp_name&rsquo;和&lsquo;func_name&rsquo;一定要加引号。</p>
<p>例：</p>
<p>SHOW PROCEDURE STATUS LIKE ‘age_from_user3‘;</p>
<p>SHOW PROCEDURE STATUS LIKE ‘age_from_user3‘\G; （按行输出）</p>
<p>*************************** 1. row ***************************</p>
<p>Db: homework （在哪个数据库下）</p>
<p>Name: age_from_user3 （存储过程的名字）</p>
<p>Type: PROCEDURE （存储过程的类型）</p>
<p>Definer: [email&#160;protected] （存储过程的定义者）</p>
<p>Modified: 2014-11-13 20:48:11 （存储过程的修改时间）</p>
<p>Created: 2014-11-13 20:48:11&nbsp; （存储过程的创建时间）</p>
<p>Security_type: DEFINER （安全类型，谁可以执行这个存储过程）</p>
<p>Comment: （注释）</p>
<p>character_set_client: gbk （客户端的字符集）</p>
<p>collation_connection: gbk_chinese_ci （校验字符集）</p>
<p>Database Collation: utf8_bin （数据库的字符集）</p>
<p>1 row in set (0.00 sec)</p>
<p>查看存储函数：</p>
<p>SHOW FUNCTION STATUS LIKE ‘username_from_user‘;</p>
<p>SHOW FUNCTION STATUS LIKE ‘username_from_user‘\G;</p>
<p>*************************** 1. row ***************************</p>
<p>Db: homework</p>
<p>Name: username_from_user</p>
<p>Type: FUNCTION</p>
<p>Definer: [email&#160;protected]</p>
<p>Modified: 2014-11-13 20:40:10</p>
<p>Created: 2014-11-13 20:40:10</p>
<p>Security_type: DEFINER</p>
<p>Comment:</p>
<p>character_set_client: gbk</p>
<p>collation_connection: gbk_chinese_ci</p>
<p>Database Collation: utf8_bin</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>10.</strong><strong>查看存储过程和存储函数的定义</strong></p>
<p><strong>SHOW CREATE PROCEDURE sp_name;</strong></p>
<p><strong>SHOW CREATE FUNCTION func_name;</strong></p>
<p>例子：</p>
<p>SHOW CREATE PROCEDURE age_from_user3\G;</p>
<p>*************************** 1. row ***************************</p>
<p>Procedure: age_from_user3</p>
<p>sql_mode: NO_ENGINE_SUBSTITUTION &nbsp;(SQL类型)</p>
<p>Create Procedure: CREATE DEFINER=`root`@`localhost` PROCEDURE `age_from_user3`(IN user_id INT,OUT user_age INT)</p>
<p>READS SQL DATA</p>
<p>BEGIN</p>
<p>SELECT age INTO user_age FROM users2</p>
<p>WHERE id=user_id;</p>
<p>END</p>
<p>character_set_client: gbk</p>
<p>collation_connection: gbk_chinese_ci</p>
<p>Database Collation: utf8_bin</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>查看函数的创建例子：</strong></p>
<p>mysql&gt; SHOW CREATE FUNCTION username_from_user\G;</p>
<p>*************************** 1. row ***************************</p>
<p>Function: username_from_user</p>
<p>sql_mode: NO_ENGINE_SUBSTITUTION</p>
<p>Create Function: CREATE DEFINER=`root`@`localhost` FUNCTION `username_from_user`(user_id INT) RETURNS varchar(20) CHARSET utf8 COLLATE utf8_bin</p>
<p>BEGIN</p>
<p>RETURN (SELECT username FROM users2 WHERE id=user_id);</p>
<p>END</p>
<p>character_set_client: gbk</p>
<p>collation_connection: gbk_chinese_ci</p>
<p>Database Collation: utf8_bin</p>
<p>1 row in set (0.00 sec)</p>
<p><strong>11. </strong><strong>查看数据库information_schema</strong><strong>中的存储过程和函数</strong></p>
<p>数据库information_schema保存了所有的存储过程和存储函数，均保存在了ROUTINES表中。</p>
<p>（1）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 切换数据库：mysql&gt; USE information_schema;</p>
<p>（2）&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 查看ROUTINES表：mysql&gt; SELECT * FROM ROUTINES\G</p>
<p>或者使用：SELECT * FROM information_schema.routines \G</p>
<p>可以根据查询结果的选项内容，进行条件查询：</p>
<p>SELECT * FROM information_schema.routines WHERE routine_type=‘FUNCTION‘ \G</p>
<p><strong>12.</strong><strong>修改存储过程和函数的属性</strong></p>
<p>我们需要明白这里的修改不是修改其中的SQL语句，而是修改它的安全性以及数据访问。我们也可以通过客户端工具进行查看和修改。</p>
<p>ALTER PROCEDURE sp_name &nbsp;[COMMENT &lsquo;string&rsquo;];</p>
<p>ALTER FUNCTION func_name&nbsp; [COMMENT &lsquo;string&rsquo;];</p>
<p><strong>修改存储过程：</strong></p>
<p>mysql&gt; ALTER PROCEDURE sp_demo1 COMMENT ‘THIS IS A TEST‘;</p>
<p>Query OK, 0 rows affected (0.00 sec)</p>
<p>mysql&gt; SHOW PROCEDURE STATUS LIKE ‘sp_demo1‘\G;</p>
<p><strong>修改存储函数：</strong></p>
<p>ALTER FUNCTION&nbsp; username_from_user COMMENT‘THIS IS A TEST OF FUCTION‘;</p>
<p>mysql&gt; SHOW FUNCTION STATUS LIKE ‘username_from_user‘\G;</p>
<p><strong>12.1 </strong><strong>存储过程的安全性</strong></p>
<p>安全类型有两个：</p>
<p>DEFINER:定义者，定义这个存储过程的人可以执行它，默认</p>
<p>INVOKER:调用者，调用这个存储过程的人可以执行它</p>
<p>SQL 数据访问选项有4个：</p>
<p>CONTAINS SQL:存储过程或者函数包含SQL语句</p>
<p>NO SQL: 存储过程或者函数不包含SQL语句</p>
<p>READS SQL DATA: 存储过程或者函数的SQL语句是读数据库的数据</p>
<p>MODIFIES SQL DATA: 存储过程或者函数的SQL语句是修改数据库的数据</p>
<p><strong>12.2 </strong><strong>修改存储过程和函数的安全性</strong></p>
<p>修改之前先查看一下属性值：</p>
<p>SELECT * FROM information_schema.routines \G</p>
<p>然后使用ALTER 语句修改存储过程proc2的安全类型和数据访问选项：</p>
<p>ALTER PROCEDURE proc2</p>
<p>MODIFIES SQL DATA</p>
<p><strong>SQL SECURITY</strong> INVOKER;</p>
<p>SHOW PROCEDURE STATUS LIKE ‘proc2‘\G</p>
<p>SELECT * FROM information_schema.routines \G</p>
<p><strong>13. </strong><strong>删除存储过程及存储函数</strong></p>
<p><strong>DROP PROCEDURE sp_name;</strong></p>
<p><strong>DROP FUNCTION sp_name;</strong></p>
<p>当删除不存在的存储过程或者存储函数的时候，会显示报错：</p>
<p>mysql&gt; DROP PROCEDURE sp_demo1;</p>
<p>ERROR 1305 (42000): PROCEDURE homework.sp_demo1 does not exist</p>
<p>如果想屏蔽错误，以警告的形式提示，可以使用：</p>
<p><strong>DROP PROCEDURE IF EXISTS &nbsp;sp_name;</strong></p>
<p><strong>DROP FUNCTION IF EXISTS &nbsp;sp_name;</strong></p>
<p>例子：</p>
<p>mysql&gt; DROP PROCEDURE IF EXISTS&nbsp; sp_name;</p>
<p>Query OK, 0 rows affected, 1 warning (0.00 sec)</p>
<p><strong>查看警告的内容：SHOW WARNINGS;</strong></p>
<p>mysql&gt; SHOW WARNINGS;</p>
<p>+-------+------+-------------------------------------------------------------------------+</p>
<p>| Level | Code | Message&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>+-------+------+-------------------------------------------------------------------------+</p>
<p>| Note | 1305 | PROCEDURE homework.sp_name does not exist &nbsp;&nbsp;|</p>
<p>+-------+------+-------------------------------------------------------------------------+</p>
<p>1 row in set (0.01 sec)</p>
<p><strong>删除存储过程例子：</strong></p>
<p>mysql&gt; DROP PROCEDURE sp_demo1;</p>
<p>Query OK, 0 rows affected (0.05 sec)</p>
<p>mysql&gt; SHOW CREATE PROCEDURE sp_demo1;</p>
<p>ERROR 1305 (42000): PROCEDURE sp_demo1 does not exist</p>
<p><strong>删除存储函数例子：</strong></p>
<p>DROP FUNCTION username_from_user;</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 23:02:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>MYSQL存储过程和函数学习笔记的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RwRJ93.html" rel="bookmark">MySql基本语法（学习笔记&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL语法大全_自己整理的学习笔记 select * from emp;  #注释 #--------------------------- #----命令行连接MySql--------- #启动mysql服务器 net start mysql #关闭 net stop mysql #进入 mysql -h 主机地址 -u 用户名 -p 用户密码 #退出 exit #--------------------------- #----MySql用户管理--------- #修改密码:首先在D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47EJyx0.html" rel="bookmark">多IDC数据分布--MySQL多机房部署 - 学习笔记 - 51CTO技术博客</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				多IDC数据分布--MySQL多机房部署 - 学习笔记 - 51CTO技术博客 多IDC数据分布--MySQL多机房部署			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xmwBL3.html" rel="bookmark">C&plus;&plus;运算符重载为友元函数学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				初探C++运算符重载学习笔记 在上面那篇博客中,写了将运算符重载为普通函数或类的成员函数这两种情况. 下面的两种情况发生,则我们需要将运算符重载为类的友元函数 &lt;1&gt;成员函数不能满足要求 &lt;2&gt;普通函数又不能访问类的私有成员时 举例说明: class Complex{ double real, imag; public: Complex(double r, double i):real(r), imag(i){ }; Complex operator+(double r); };			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Ndoyw0.html" rel="bookmark">contiki-main&period;c 中的process系列函数学习笔记 &amp;lt&semi;contiki学习笔记之六&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明:本文依然依赖于 contiki/platform/native/contiki-main.c 文件. ------------------------------------------------------------------------------------------------------------------------------------- 根据上一个笔记里面添加的printf()语句的打印信息提示,hello world 打印是在执行了 1 autostart_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG8ZoA0.html" rel="bookmark">MySql存储过程、函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				存储过程和函数是在数据库中定义一些SQL语句的集合,然后直接调用这些存储过程和函数来执行已经定义好的SQL语句.存储过程和函数可以避免开发人员重复的编写相同的SQL语句.而且,存储过程和函数是在MySQL服务器中存储和执行的,可以减少客户端和服务器端的数据传输.一.存储过程1.1.基本语法 CREATE PROCEDURE sp_name ([proc_parameter[,...]])     [characteristic ...] routine_body Sp_name:存储过程的名称,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBaAxZ4.html" rel="bookmark">7 MySQL存储过程和函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录: 1. 存储过程和函数概述2. 准备工作3. 存储过程操作4. 创建带参存储过程5. 查看存储过程 1. 存储过程和函数概述 MySQL的存储过程(stored procedure)和函数(stored function)统称为stored routines. 存储过程和函数都是事先经过编译并存储在数据库中的一段SQL语句的集合,调用存储过程和函数可以简化应用开发人员的很多工作,减少数据在数据库和应用服务器之间的传输. 存储过程和函数的区别在于函数必须有返回值,而存储过程没有,存储过程的参			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qxola0.html" rel="bookmark">九、MySQL存储过程和函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				存储过程就是一条或者多条SQL语句的集合,可视为批文件,但是其作用不仅限于批处理. 9.1.创建存储过程和函数 存储程序可以分为存储过程和函数,MySQL中创建存储过程和函数使用的语句分别是CREATE PROCEDURE和CREATE FUNCTION.使用CALL语句来调用存储过程,只能用输出变量返回值.函数可以从语句外调用( 即通过引用函数名),也能返回标量值.存储过程也能调用其他存储过程. 创建存储过程 创建存储过程,需要使用CREATE PROCEDURE语句,基本语法为: CREAT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPZJwy3.html" rel="bookmark">MySql存储过程与函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				林炳文Evankaka原创作品.转载请注明出处http://blog.csdn.net/evankaka 摘要:存储过程和函数是在数据库中定义一些SQL语句的集合,然后直接调用这些存储过程和函数来运行已经定义好的SQL语句.存储过程和函数能够避免开发者反复的编写同样的SQL语句.而且,存储过程和函数是在MySQLserver中存储和运行的.能够降低client和server端的传输数据. 一.存储过程 1.1.基本的语法 CREATE PROCEDURE sp_name ([proc_param			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ljm5p4.html" rel="bookmark">mysql存储过程和函数的操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL在5.0版本开始有存储过程功能: 存储过程和函数是事先经过编译并存储在数据库中的一条SQL语句集合: 存储过程和函数的区别:函数必须有返回值,存储过程则没有: 1.1 创建存储过程语法形式 delimiter $$ create procedure procedure_name ([procedure_paramter,]) [characteristic...] routine_body $$ delimter ; 注:procedure_paramter为参数,可有可无,形式为:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rOn74.html" rel="bookmark" class="title">使用Servlet实现上传文件功能</a>
					<div>
						1.servlet只需加上一个注释和用request.getPart来获取文件的值,这是servlet3.0的API 2.表单需要加上一个属性enctype=&quot;multipart/form- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaXQ7M.html" rel="bookmark" class="title">bbs项目应用三</a>
					<div>
						项目应用三:定义项目初始化文件和入口文件 创建项目初始化文件 所谓的项目初始化文件就是基本上每个脚本都要使用的文件!里面定义一些最常用的基本代码! 在根目录下创建初始化文件init.php: 完善in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYKmy3.html" rel="bookmark" class="title">Sublime Text3使用总结</a>
					<div>
						写在前面的话:平时做项目中在用eclipse和vs,但是对于一些小项目,感觉没有必要搞那么大的一个工具使用,比如写个小微商城,搞个小脚本了什么,所以就一直在用Sublime Text,界面清新简洁,没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdxNVM.html" rel="bookmark" class="title">算法与数据结构之折半查找（C语言）</a>
					<div>
						1 #include &lt;stdio.h&gt; 2 #include&lt;stdlib.h&gt; 3 4 int binsearch(int x,int v[],int n);//函数声明  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j7nDe3.html" rel="bookmark" class="title">stl string常用函数</a>
					<div>
						string类的构造函数: string(const char *s); //用c字符串s初始化 string(int n,char c); //用n个字符c初始化 此外,string类还支持默认构造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRKky0.html" rel="bookmark" class="title">POJ 1442 Black Box treap求区间第k大</a>
					<div>
						题目来源:POJ 1442 Black Box 题意:输入xi 输出前xi个数的第i大的数 思路:试了下自己的treap模版 #include &lt;cstdio&gt; #include &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKWGE3.html" rel="bookmark" class="title">linux &mdash;&mdash; 学习笔记（用户管理与权限控制）</a>
					<div>
						目录:1.用户的创建和管理    2.组的创建和管理 3.文件执行权限的控制 4.不用密码执行sudo 1.用户的创建和管理 用户的创建和管理: useradd.usermod . userdel . ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49rGqpM.html" rel="bookmark" class="title">Bzoj 1696&colon; &lbrack;Usaco2007 Feb&rsqb;Building A New Barn新牛舍  中位数&comma;数学</a>
					<div>
						1696: [Usaco2007 Feb]Building A New Barn新牛舍 Time Limit: 5 Sec  Memory Limit: 64 MBSubmit: 394  Solve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvRwv3.html" rel="bookmark" class="title">搬山游戏</a>
					<div>
						问题; 设有n座山,计算机与人作为比赛双方,轮流搬山,规定每次搬山数不超过k,谁搬最后一座山谁输. #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8zBy4.html" rel="bookmark" class="title">图片&plus;css实现半透明引导页</a>
					<div>
						先上效果图: css: .ydy{ width:100%; height:100%; overflow:hidden; background-color:#000000; filter:alpha(o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BvgPM.html" rel="bookmark" class="title">php的static关键字和全局变量</a>
					<div>
						1.全局变量[其不属于面向对象的思想,因为其放在对象之外的],面向对象有一个特点,其实封装的,php希望其所有的成员都应该放在类中:php的面向对象是基于面向对象的,不是纯粹面向对象的:也就是其可以面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1eNd4.html" rel="bookmark" class="title">洛谷P2320 鬼谷子的钱袋</a>
					<div>
						P2320 06湖南 鬼谷子的钱袋 171通过 480提交 题目提供者xmyzwls 标签各省省选 难度普及+/提高 提交该题 讨论 题解 记录 最新讨论 题目有误 数据需要特判 评测系统太神了 题目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNzyg4.html" rel="bookmark" class="title">&lbrack;cocos2dx笔记003&rsqb; Vs2013添加静态库project</a>
					<div>
						(基于2.2.2版本号.用vs2013编辑代码)(cppblog版本号:http://www.cppblog.com/zdhsoft/archive/2014/05/11/206890.html) 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kp1aj3.html" rel="bookmark" class="title">poj 1228 Grandpa&amp;&num;39&semi;s Estate&lpar;凸包&rpar;</a>
					<div>
						Grandpa's Estate Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 11508   Accepted: 3188 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e72xD4.html" rel="bookmark" class="title">kickstart无人值守安装Linux</a>
					<div>
						kickstart无人值守安装Linux 1.安装vsftpd.tftp-server.dhcp-server和kickstart yum -y install vsftpd tftp* dhcp k ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022qdD0.html" rel="bookmark" class="title">bash命令</a>
					<div>
						整理bash命令类型,验证寻找一个命令的优先级 bash命令优先级表:1别名  由alias指定2关键字  3函数  由function(){}定义4内置命令  builtin命令5脚本或可执行程序  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERrVx0.html" rel="bookmark" class="title">25k英里高速建48个充电走廊，美国电动汽车产业迎来春天</a>
					<div>
						[阅读原文] 作者:楠沨 近两年来,美国电动汽车呈现出爆炸性增长局面.从2010年到2014年初,全美已售出超过19万台电动汽车,以2013年为例,美国电动车售出9.6万辆,2012年则为5.3万辆, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqppa3.html" rel="bookmark" class="title">Linux的启动流程&lpar;CentOS 7&rpar;</a>
					<div>
						前言 Linux启动的过程在实际生产中有着至关重要的作用.试想一下,如果我们在实际生产中服务器因为某一个服务出了问题,而不能启动,这时我们应该怎么办.如果我们了解Linux的详细启动过程,知道是在哪一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3On5690.html" rel="bookmark" class="title">pthread的各种同步机制</a>
					<div>
						https://casatwy.com/pthreadde-ge-chong-tong-bu-ji-zhi.html pthread是POSIX标准的多线程库,UNIX.Linux上广泛使用,wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvExjM.html" rel="bookmark" class="title">C&plus;&plus;中的运算符重载注意事项</a>
					<div>
						1.C++中的运算符重载的方式有三种: a.类成员函数重载 b.友元函数重载 c.普通函数重载 注意: a.我们主要使用的方式主要是用:类成员函数和友元函数来实现运算符的重载. b.其实用普通函数理论 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
